var rl = require('readline'),
	fs = require('fs'),
    sys = require('sys');

var env = require('./lib/env'),
	global = require('./lib/global');

exports.global = global;

var parse = require('./lib/parse').parse;
exports.parse = parse;

require.extensions['.jils'] = function(md, file){
	var mdenv = env.mkenv([],[],global);
	parse('(begin '
		+fs.readFileSync(file, 'utf-8')
			+')', mdenv);
	if ('public' in mdenv.values)
		md.exports = env.eget(mdenv,'public');
};


var interactive = false;
if (process.argv.length > 1){
	var args = process.argv.slice(1);
		script = (__filename.split('/').pop());
	if (args[0].indexOf(script) > -1){
		args = args.slice(1);
	}
	if (args[0] === '-i'){
		interactive = true;
		args = args.slice(1);
	}
	if (!args.length) interactive = true;	

	args.forEach(function(file){
		parse('(begin '
			+fs.readFileSync(process.env.PWD+'/'+file, 'utf-8')
				+')', global);
	});
} else {
	interactive = false;
}

if (interactive) {
	var repl = rl.createInterface(
		process.stdin, 
		process.stdout, null);

	var prompt = 'jils> ',
		colors = {
			pre: "\033[1;34m", 
			post: "\033[m"
		};

	var issue = fs.readFileSync('./issue.txt');
	console.log(issue.toString());	
	
	repl.question(prompt, function next(input){
		if (!input) return repl.question(prompt, next);
		switch (input.split(' ')[0]){
			case ':q': process.exit(0);
		} 
		var result = parse(input, global),
			output = colors.pre + result + colors.post;
		console.log('\n',output);
		repl.question(prompt, next);
	});
}
