module.exports = {
	mkenv: mkenv,
	mkhash: mkhash,
	find: find,
	eset: eset,
	eget: eget,
	keys: keys,
	values: values
};

function mkenv(keys, values, outer){
	return {
		'values': mkhash(keys, values),
		'outer': outer
	};
}

function mkhash(keys, values){
	var hash = {};
	for (var i in keys){
		hash[keys[i]] = values[i];
	} return hash;
}

function find(env, key){
	if (env.values.hasOwnProperty(key))
		return env;
	if (env.outer) 
		return find(env.outer, key);
}

function eset(env, key, value){
	return (find(env, key).values[key] = value);
}

function eget(env, key){
	return find(env, key).values[key];
}

function keys(obj){
	return Object.keys(obj);
}

function values(obj){
	return keys(obj).map(function(x){
		return obj[x];
	});
}
