var env = require('./env'),
	core = require('./core'),
	fs = require('fs'),
	slice = Array.prototype.slice;

module.exports = {
	'defn': defn,
	'obj': obj,
	'load': load,
	'use': use,
	'let': let
};

for (func in module.exports)
	module.exports[func].__macro = true;

function defn(name, args, body){
	return ['def',name,['fn',args,body]];
}

function obj(){
	return ['hash',['list'].concat(slice.call(arguments))];
}

function load(rel){
	var defs = {};
	if (rel.match(/\/\*$/)){
		var _ = [],
			dir = rel.replace(/\/\*$/,'');
		fs.readdirSync(process.env.PWD+'/'+dir).map(function(rel){
			if (rel.match(/\.jils$/)){
				var loc = process.env.PWD+'/'+dir+'/'+rel;
				_.push(require(require.resolve(loc)));
			}
		});
		_.map(function(_){
			for (var key in _){
				defs[key] = _[key];
			}
		});
	} else {
		var _ = require(require.resolve(process.env.PWD+'/'+rel));
		for (var key in _){
			defs[key] = _[key];
		}
	} return defs;
}

function use(rel){
	var defs = [];
	if (rel.match(/\/\*$/)){
		var _ = [],
			dir = rel.replace(/\/\*$/,'');
		fs.readdirSync('./lib/'+dir).map(function(rel){
			if (rel.match(/\.jils$/)){
				var loc = './'+dir+'/'+rel;
				_.push(require(loc));
			}
		});
		_.map(function(_){
			for (var key in _){
				defs.push(['def',key,_[key]]);
			}
		});
	} else {
		var _ = require('./'+rel);
		for (var key in _){
			defs.push(['def',key,_[key]]);
		}
	} return ['do'].concat(defs).concat(true);
}

function let(){
	var _ = ['do'];
	for (var a = 0, l = arguments.length; a < l; a++){
		if (core.arrayp(arguments[a][0]))
			_.push(['assoc',arguments[a][0],arguments[a][1]]);
		else _.push(['def',arguments[a][0],arguments[a][1]])
	} return _;
}
